		// Widget Killer - version 3.0
		// 5 December, 2007
		// Copyright © 2005-2007 by Laurent Cozic and Harry Whitfield
		// mailto:g6auc@arrl.net

		include("Menu.js");
		
		var PATH = resolvePath(".");	//PATH=.../WidgetName.widget/Contents
		print("PATH=" + PATH);
		var idx = PATH.lastIndexOf(".widget/Contents");
		var temp = PATH.substring(0,idx);
		idx = temp.lastIndexOf("/");
		var thisWidgetName = temp.substring(idx+1);
		print('thisWidgetName=' + thisWidgetName);

		var gGetProcessListPath = undefined, gProcessKillerPath = undefined;
		var widgetMenu = null, keyDict = null, shortKeyDict = null;
		var alertOpen = false;
		
		function listActiveWidgets() {
						
			function esc(s) { return s.replace(/([\W])/g,'\\$1'); }
			
			var i, output, konCOM, runningWidgets, runningWidget;
			var psTable, activeList, data, lookFor, found;

			if (system.platform == "windows") {
				updateNow();
				
				output = "";
				try {
					konCOM = COM.createObject("YahooWidgetEngine.Application");
					runningWidgets = konCOM.RunningWidgets;
					for (i = 0; i < runningWidgets.count; i += 1) {
						if (output !== "") { output += "\n"; }
						runningWidget = runningWidgets.item(i);
						output += "0," + runningWidget.name;
					}					
				} catch(e) {
					print("[Error] YahooWidgetEngine COM: " + e);
				}
				runningWidgets = null;	
				konCOM = null;
				output += "\n";
				
				return output;
			} else {
				psTable = runCommand('ps -xww').split('\n');
				activeList = "";
				for (i = 0; i < psTable.length; i += 1) {
					data = psTable[i];
					lookFor = '\\D*' + '(\\d+)' + '\\D.*?' + esc('/') + '([^\\/]+)' + esc('.kon ');
					found = data.match(lookFor);
					if (found !== null) { activeList += found[1] + ',' + found[2] + '.kon\n'; }
					else {
						lookFor = '\\D*' + '(\\d+)' + '\\D.*?' + esc('/') + '([^\\/]+)' + esc('.widget ');
						found = data.match(lookFor);
						if (found !== null) { activeList += found[1] + ',' + found[2] + '.widget\n'; }
					}
				}
				return activeList;
			}
		}
		
		function getKeys(widgetName)
		{			
			var ps = listActiveWidgets(), item,  pid, wname, res = "", i;			
			if (ps === "") { return; }
			var psTable = ps.split('\n');
			for (i = 0; i < psTable.length - 1; i += 1) {
				item  = psTable[i].split(',');
				pid   = item[0];
				wname = item[1];
				if ((wname == "Widget Killer") || (wname == "Yahoo! Widgets")) { continue; }
				if (wname != widgetName) {
					if (res === "") { res += wname; } else { res += '\r' + wname; }
				}
			}
			return res;
		}

		function killWidget(widgetName)
		{
			var item, pid, wname, konCOM, i;
			var ps = listActiveWidgets();
			if (ps === "") { return; }
			var psTable = ps.split('\n');
			for (i = 0; i < psTable.length - 1; i += 1)
			{
				item = psTable[i].split(',');
				pid = item[0];
				wname = item[1];
				if (wname == widgetName) {
					if (system.platform == "windows") {
						try {
							konCOM = COM.createObject("YahooWidgetEngine.Application");
							konCOM.CloseWidget(widgetName);
						} catch(e) {
							print("[Error] YahooWidgetEngine COM: " + e);
						}
						konCOM = null;
					} else {
						runCommand('kill -9 ' + pid);
					}
				}
			}
		}

		function printDict(s, dict)
		{
			print("----- " + s + "  -----");
			for (var i = 0; i < dict.length; i += 1) {
				print(dict[i]);
			}
		}

		function stripDict(dict)
		{
			var shortDict = [], item, idx;
			for (var i = 0; i < dict.length; i += 1) {
				item = dict[i];
				idx  = item.lastIndexOf(".widget");
				if (idx >= 0) { item = item.substring(0, idx); }
				else
				{
					idx  = item.lastIndexOf(".kon");
					if (idx >= 0) { item = item.substring(0, idx); }
				}
				shortDict[i] = item;
			}
			return shortDict;
		}

		function openAlertWindow()
		{
			alertOpen = true;
			alert_window.hOffset = (screen.width>>1) - 210;
			alert_window.vOffset = 250;
			alert_window.level="topMost";
			alert_window.visible = true;
			alert_timer.interval = preferences.alert_timerPref.value;
			alert_timer.ticking  = true;
			if (preferences.alert_beepPref.value == "1") { beep(); }
		}

		function closeAlertWindow()
		{
			alert_timer.ticking  = false;
			alert_window.visible = false;
			alertOpen = false;
		}

		function menuAction()
		{
			var i = this.i;
			var data = keyDict[i];
			print('killing: ' + data);
			killWidget(data);
		}

		function mouseEnter()
		{
			if (alertOpen) { return; }
			
			var widgets = getKeys(thisWidgetName + '.widget');
			if (widgets !== "") {
				keyDict = widgets.split("\r").sort();
				shortKeyDict = stripDict(keyDict);
				widgetMenu.reset(shortKeyDict, "");
				printDict("keyDict", keyDict);
				printDict("shortKeyDict", shortKeyDict);
			}
			else { keyDict = null; print('No other widgets are running.'); }
		}

		function mouseDown()
		{
			if (alertOpen) { if (preferences.alert_beepPref.value == "1") { beep(); } return; }
			if (keyDict !== null) { widgetMenu.select(); } else { openAlertWindow(); }
		}

		widgetMenu = new Menu(kill, [ ], "", menuAction);	// create widgetMenu

		if (system.platform == "windows") {
			alert_image.src     = "Resources/Images/alertXP.png"
			alert_window.width  = alert_image.srcWidth;
			alert_window.height = alert_image.srcHeight;
			alert_image.width   = alert_image.srcWidth;
			alert_image.height  = alert_image.srcHeight;
		}
